blob: 8a922893f75f220a8fce59a605405aceeaf91d7e [file] [log] [blame]
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -05001#!/bin/sh
2#
3# This program resolves merge conflicts in git
4#
5# Copyright (c) 2006 Theodore Y. Ts'o
David Aguilar8827b3a2016-10-07 16:58:03 -07006# Copyright (c) 2009-2016 David Aguilar
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -05007#
8# This file is licensed under the GPL v2, or a later version
Josh Triplett2571ac62007-06-05 21:24:19 -07009# at the discretion of Junio C Hamano.
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050010#
11
Denton Liu063f2bd2018-10-24 12:25:31 -040012USAGE='[--tool=tool] [--tool-help] [-y|--no-prompt|--prompt] [-g|--gui|--no-gui] [-O<orderfile>] [file to merge] ...'
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050013SUBDIRECTORY_OK=Yes
Charles Bailey7bfb7c32014-10-11 01:39:37 -070014NONGIT_OK=Yes
Junio C Hamano8f321a32007-11-06 01:50:02 -080015OPTIONS_SPEC=
David Aguilar21d0ba72009-04-08 00:17:20 -070016TOOL_MODE=merge
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050017. git-sh-setup
David Aguilar21d0ba72009-04-08 00:17:20 -070018. git-mergetool--lib
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050019
20# Returns true if the mode reflects a symlink
Theodore Ts'o262c9812007-03-29 06:55:11 -040021is_symlink () {
Junio C Hamanof8750a02012-08-22 22:33:15 -070022 test "$1" = 120000
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050023}
24
Jonathon Mahff7f0892011-04-13 03:00:48 -070025is_submodule () {
Junio C Hamanof8750a02012-08-22 22:33:15 -070026 test "$1" = 160000
Jonathon Mahff7f0892011-04-13 03:00:48 -070027}
28
Theodore Ts'o262c9812007-03-29 06:55:11 -040029local_present () {
Junio C Hamanof8750a02012-08-22 22:33:15 -070030 test -n "$local_mode"
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050031}
32
Theodore Ts'o262c9812007-03-29 06:55:11 -040033remote_present () {
Junio C Hamanof8750a02012-08-22 22:33:15 -070034 test -n "$remote_mode"
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050035}
36
Theodore Ts'o262c9812007-03-29 06:55:11 -040037base_present () {
Junio C Hamanof8750a02012-08-22 22:33:15 -070038 test -n "$base_mode"
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050039}
40
David Aguilar8f0cb412014-10-11 10:04:45 -070041mergetool_tmpdir_init () {
42 if test "$(git config --bool mergetool.writeToTemp)" != true
43 then
44 MERGETOOL_TMPDIR=.
45 return 0
46 fi
47 if MERGETOOL_TMPDIR=$(mktemp -d -t "git-mergetool-XXXXXX" 2>/dev/null)
48 then
49 return 0
50 fi
51 die "error: mktemp is needed when 'mergetool.writeToTemp' is true"
52}
53
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050054cleanup_temp_files () {
Junio C Hamanof8750a02012-08-22 22:33:15 -070055 if test "$1" = --save-backup
56 then
57 rm -rf -- "$MERGED.orig"
58 test -e "$BACKUP" && mv -- "$BACKUP" "$MERGED.orig"
59 rm -f -- "$LOCAL" "$REMOTE" "$BASE"
60 else
61 rm -f -- "$LOCAL" "$REMOTE" "$BASE" "$BACKUP"
62 fi
David Aguilar8f0cb412014-10-11 10:04:45 -070063 if test "$MERGETOOL_TMPDIR" != "."
64 then
65 rmdir "$MERGETOOL_TMPDIR"
66 fi
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050067}
68
Theodore Ts'o262c9812007-03-29 06:55:11 -040069describe_file () {
Junio C Hamanof8750a02012-08-22 22:33:15 -070070 mode="$1"
71 branch="$2"
72 file="$3"
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050073
Junio C Hamanof8750a02012-08-22 22:33:15 -070074 printf " {%s}: " "$branch"
75 if test -z "$mode"
76 then
77 echo "deleted"
78 elif is_symlink "$mode"
79 then
80 echo "a symbolic link -> '$(cat "$file")'"
81 elif is_submodule "$mode"
82 then
83 echo "submodule commit $file"
84 elif base_present
85 then
86 echo "modified file"
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050087 else
Junio C Hamanof8750a02012-08-22 22:33:15 -070088 echo "created file"
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050089 fi
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050090}
91
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -050092resolve_symlink_merge () {
Junio C Hamanof8750a02012-08-22 22:33:15 -070093 while true
94 do
95 printf "Use (l)ocal or (r)emote, or (a)bort? "
96 read ans || return 1
97 case "$ans" in
98 [lL]*)
99 git checkout-index -f --stage=2 -- "$MERGED"
100 git add -- "$MERGED"
101 cleanup_temp_files --save-backup
102 return 0
103 ;;
104 [rR]*)
105 git checkout-index -f --stage=3 -- "$MERGED"
106 git add -- "$MERGED"
107 cleanup_temp_files --save-backup
108 return 0
109 ;;
110 [aA]*)
111 return 1
112 ;;
113 esac
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -0500114 done
115}
116
117resolve_deleted_merge () {
Junio C Hamanof8750a02012-08-22 22:33:15 -0700118 while true
119 do
120 if base_present
121 then
122 printf "Use (m)odified or (d)eleted file, or (a)bort? "
123 else
124 printf "Use (c)reated or (d)eleted file, or (a)bort? "
125 fi
126 read ans || return 1
127 case "$ans" in
128 [mMcC]*)
129 git add -- "$MERGED"
David Aguilara2986042016-03-09 23:13:59 -0800130 if test "$merge_keep_backup" = "true"
131 then
132 cleanup_temp_files --save-backup
133 else
134 cleanup_temp_files
135 fi
Junio C Hamanof8750a02012-08-22 22:33:15 -0700136 return 0
137 ;;
138 [dD]*)
139 git rm -- "$MERGED" > /dev/null
140 cleanup_temp_files
141 return 0
142 ;;
143 [aA]*)
David Aguilara2986042016-03-09 23:13:59 -0800144 if test "$merge_keep_temporaries" = "false"
145 then
146 cleanup_temp_files
147 fi
Junio C Hamanof8750a02012-08-22 22:33:15 -0700148 return 1
149 ;;
150 esac
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -0500151 done
152}
153
Jonathon Mahff7f0892011-04-13 03:00:48 -0700154resolve_submodule_merge () {
Junio C Hamanof8750a02012-08-22 22:33:15 -0700155 while true
156 do
157 printf "Use (l)ocal or (r)emote, or (a)bort? "
158 read ans || return 1
159 case "$ans" in
160 [lL]*)
161 if ! local_present
162 then
163 if test -n "$(git ls-tree HEAD -- "$MERGED")"
164 then
165 # Local isn't present, but it's a subdirectory
166 git ls-tree --full-name -r HEAD -- "$MERGED" |
167 git update-index --index-info || exit $?
168 else
169 test -e "$MERGED" && mv -- "$MERGED" "$BACKUP"
170 git update-index --force-remove "$MERGED"
171 cleanup_temp_files --save-backup
172 fi
173 elif is_submodule "$local_mode"
174 then
175 stage_submodule "$MERGED" "$local_sha1"
176 else
177 git checkout-index -f --stage=2 -- "$MERGED"
178 git add -- "$MERGED"
179 fi
180 return 0
181 ;;
182 [rR]*)
183 if ! remote_present
184 then
185 if test -n "$(git ls-tree MERGE_HEAD -- "$MERGED")"
186 then
187 # Remote isn't present, but it's a subdirectory
188 git ls-tree --full-name -r MERGE_HEAD -- "$MERGED" |
189 git update-index --index-info || exit $?
190 else
191 test -e "$MERGED" && mv -- "$MERGED" "$BACKUP"
192 git update-index --force-remove "$MERGED"
193 fi
194 elif is_submodule "$remote_mode"
195 then
196 ! is_submodule "$local_mode" &&
197 test -e "$MERGED" &&
198 mv -- "$MERGED" "$BACKUP"
199 stage_submodule "$MERGED" "$remote_sha1"
200 else
201 test -e "$MERGED" && mv -- "$MERGED" "$BACKUP"
202 git checkout-index -f --stage=3 -- "$MERGED"
203 git add -- "$MERGED"
204 fi
Jonathon Mahff7f0892011-04-13 03:00:48 -0700205 cleanup_temp_files --save-backup
Junio C Hamanof8750a02012-08-22 22:33:15 -0700206 return 0
207 ;;
208 [aA]*)
209 return 1
210 ;;
211 esac
Jonathon Mahff7f0892011-04-13 03:00:48 -0700212 done
213}
214
215stage_submodule () {
Junio C Hamanof8750a02012-08-22 22:33:15 -0700216 path="$1"
217 submodule_sha1="$2"
218 mkdir -p "$path" ||
219 die "fatal: unable to create directory for module at $path"
220 # Find $path relative to work tree
221 work_tree_root=$(cd_to_toplevel && pwd)
222 work_rel_path=$(cd "$path" &&
223 GIT_WORK_TREE="${work_tree_root}" git rev-parse --show-prefix
224 )
225 test -n "$work_rel_path" ||
226 die "fatal: unable to get path of module $path relative to work tree"
227 git update-index --add --replace --cacheinfo 160000 "$submodule_sha1" "${work_rel_path%/}" || die
Jonathon Mahff7f0892011-04-13 03:00:48 -0700228}
229
Charles Bailey0ec7b6c2009-01-21 22:57:48 +0000230checkout_staged_file () {
Johannes Sixt8b014652019-06-12 18:33:47 +0200231 tmpfile="$(git checkout-index --temp --stage="$1" "$2" 2>/dev/null)" &&
232 tmpfile=${tmpfile%%' '*}
Charles Bailey0ec7b6c2009-01-21 22:57:48 +0000233
Elia Pinto1cb49372014-06-06 07:55:51 -0700234 if test $? -eq 0 && test -n "$tmpfile"
Junio C Hamanof8750a02012-08-22 22:33:15 -0700235 then
236 mv -- "$(git rev-parse --show-cdup)$tmpfile" "$3"
237 else
238 >"$3"
239 fi
Charles Bailey0ec7b6c2009-01-21 22:57:48 +0000240}
241
Seth House98ea3092021-02-09 13:07:10 -0700242hide_resolved () {
243 git merge-file --ours -q -p "$LOCAL" "$BASE" "$REMOTE" >"$LCONFL"
244 git merge-file --theirs -q -p "$LOCAL" "$BASE" "$REMOTE" >"$RCONFL"
245 mv -- "$LCONFL" "$LOCAL"
246 mv -- "$RCONFL" "$REMOTE"
247}
248
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -0500249merge_file () {
Junio C Hamanof8750a02012-08-22 22:33:15 -0700250 MERGED="$1"
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -0500251
Junio C Hamanof8750a02012-08-22 22:33:15 -0700252 f=$(git ls-files -u -- "$MERGED")
253 if test -z "$f"
254 then
255 if test ! -f "$MERGED"
256 then
257 echo "$MERGED: file not found"
258 else
259 echo "$MERGED: file does not need merging"
260 fi
261 return 1
262 fi
263
Johannes Sixt8b014652019-06-12 18:33:47 +0200264 # extract file extension from the last path component
265 case "${MERGED##*/}" in
266 *.*)
267 ext=.${MERGED##*.}
268 BASE=${MERGED%"$ext"}
269 ;;
270 *)
David Aguilareab335c2014-10-10 01:19:47 -0700271 BASE=$MERGED
272 ext=
Johannes Sixt8b014652019-06-12 18:33:47 +0200273 esac
David Aguilar8f0cb412014-10-11 10:04:45 -0700274
Seth Housede8dafb2021-02-09 13:07:11 -0700275 initialize_merge_tool "$merge_tool" || return
276
David Aguilar8f0cb412014-10-11 10:04:45 -0700277 mergetool_tmpdir_init
278
279 if test "$MERGETOOL_TMPDIR" != "."
280 then
281 # If we're using a temporary directory then write to the
282 # top-level of that directory.
283 BASE=${BASE##*/}
284 fi
285
286 BACKUP="$MERGETOOL_TMPDIR/${BASE}_BACKUP_$$$ext"
287 LOCAL="$MERGETOOL_TMPDIR/${BASE}_LOCAL_$$$ext"
Seth House98ea3092021-02-09 13:07:10 -0700288 LCONFL="$MERGETOOL_TMPDIR/${BASE}_LOCAL_LCONFL_$$$ext"
David Aguilar8f0cb412014-10-11 10:04:45 -0700289 REMOTE="$MERGETOOL_TMPDIR/${BASE}_REMOTE_$$$ext"
Seth House98ea3092021-02-09 13:07:10 -0700290 RCONFL="$MERGETOOL_TMPDIR/${BASE}_REMOTE_RCONFL_$$$ext"
David Aguilar8f0cb412014-10-11 10:04:45 -0700291 BASE="$MERGETOOL_TMPDIR/${BASE}_BASE_$$$ext"
Junio C Hamanof8750a02012-08-22 22:33:15 -0700292
Johannes Sixt7e6d6f72019-06-12 18:33:48 +0200293 base_mode= local_mode= remote_mode=
294
295 # here, $IFS is just a LF
296 for line in $f
297 do
298 mode=${line%% *} # 1st word
299 sha1=${line#"$mode "}
300 sha1=${sha1%% *} # 2nd word
301 case "${line#$mode $sha1 }" in # remainder
302 '1 '*)
303 base_mode=$mode
304 ;;
305 '2 '*)
306 local_mode=$mode local_sha1=$sha1
307 ;;
308 '3 '*)
309 remote_mode=$mode remote_sha1=$sha1
310 ;;
311 esac
312 done
Junio C Hamanof8750a02012-08-22 22:33:15 -0700313
314 if is_submodule "$local_mode" || is_submodule "$remote_mode"
315 then
316 echo "Submodule merge conflict for '$MERGED':"
Junio C Hamanof8750a02012-08-22 22:33:15 -0700317 describe_file "$local_mode" "local" "$local_sha1"
318 describe_file "$remote_mode" "remote" "$remote_sha1"
319 resolve_submodule_merge
320 return
321 fi
322
David Aguilarfaaab8d2016-03-09 23:13:58 -0800323 if test -f "$MERGED"
324 then
325 mv -- "$MERGED" "$BACKUP"
326 cp -- "$BACKUP" "$MERGED"
327 fi
328 # Create a parent directory to handle delete/delete conflicts
329 # where the base's directory no longer exists.
330 mkdir -p "$(dirname "$MERGED")"
Junio C Hamanof8750a02012-08-22 22:33:15 -0700331
332 checkout_staged_file 1 "$MERGED" "$BASE"
333 checkout_staged_file 2 "$MERGED" "$LOCAL"
334 checkout_staged_file 3 "$MERGED" "$REMOTE"
335
Seth House9d9cf232021-02-09 13:07:12 -0700336 # hideResolved preferences hierarchy.
337 global_config="mergetool.hideResolved"
338 tool_config="mergetool.${merge_tool}.hideResolved"
339
340 if enabled=$(git config --type=bool "$tool_config")
341 then
342 # The user has a specific preference for a specific tool and no
343 # other preferences should override that.
344 : ;
345 elif enabled=$(git config --type=bool "$global_config")
346 then
347 # The user has a general preference for all tools.
348 #
349 # 'true' means the user likes the feature so we should use it
350 # where possible but tool authors can still override.
351 #
352 # 'false' means the user doesn't like the feature so we should
353 # not use it anywhere.
354 if test "$enabled" = true && hide_resolved_enabled
355 then
356 enabled=true
357 else
358 enabled=false
359 fi
360 else
Jonathan Niederb2a51c12021-03-13 00:38:48 -0800361 # The user does not have a preference. Default to disabled.
362 enabled=false
Seth House9d9cf232021-02-09 13:07:12 -0700363 fi
364
365 if test "$enabled" = true
Seth House98ea3092021-02-09 13:07:10 -0700366 then
367 hide_resolved
368 fi
369
Elia Pinto1cb49372014-06-06 07:55:51 -0700370 if test -z "$local_mode" || test -z "$remote_mode"
Junio C Hamanof8750a02012-08-22 22:33:15 -0700371 then
372 echo "Deleted merge conflict for '$MERGED':"
373 describe_file "$local_mode" "local" "$LOCAL"
374 describe_file "$remote_mode" "remote" "$REMOTE"
375 resolve_deleted_merge
David Aguilarfaaab8d2016-03-09 23:13:58 -0800376 status=$?
377 rmdir -p "$(dirname "$MERGED")" 2>/dev/null
378 return $status
Junio C Hamanof8750a02012-08-22 22:33:15 -0700379 fi
380
381 if is_symlink "$local_mode" || is_symlink "$remote_mode"
382 then
383 echo "Symbolic link merge conflict for '$MERGED':"
384 describe_file "$local_mode" "local" "$LOCAL"
385 describe_file "$remote_mode" "remote" "$REMOTE"
386 resolve_symlink_merge
387 return
388 fi
389
390 echo "Normal merge conflict for '$MERGED':"
391 describe_file "$local_mode" "local" "$LOCAL"
392 describe_file "$remote_mode" "remote" "$REMOTE"
Felipe Contreras4ecc63d2014-04-20 19:17:34 -0500393 if test "$guessed_merge_tool" = true || test "$prompt" = true
Junio C Hamanof8750a02012-08-22 22:33:15 -0700394 then
395 printf "Hit return to start merge resolution tool (%s): " "$merge_tool"
396 read ans || return 1
397 fi
398
399 if base_present
400 then
401 present=true
Theodore Ts'oce5b6d72007-03-27 18:00:03 -0400402 else
Junio C Hamanof8750a02012-08-22 22:33:15 -0700403 present=false
Charles Bailey162eba82008-12-12 21:48:41 +0000404 fi
405
Junio C Hamanof8750a02012-08-22 22:33:15 -0700406 if ! run_merge_tool "$merge_tool" "$present"
407 then
408 echo "merge of $MERGED failed" 1>&2
409 mv -- "$BACKUP" "$MERGED"
Charles Bailey44c36d12008-02-21 23:30:02 +0000410
Junio C Hamanof8750a02012-08-22 22:33:15 -0700411 if test "$merge_keep_temporaries" = "false"
412 then
413 cleanup_temp_files
414 fi
Charles Bailey44c36d12008-02-21 23:30:02 +0000415
Junio C Hamanof8750a02012-08-22 22:33:15 -0700416 return 1
417 fi
418
419 if test "$merge_keep_backup" = "true"
420 then
421 mv -- "$BACKUP" "$MERGED.orig"
422 else
423 rm -- "$BACKUP"
424 fi
425
426 git add -- "$MERGED"
427 cleanup_temp_files
428 return 0
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -0500429}
430
Junio C Hamanof8750a02012-08-22 22:33:15 -0700431prompt_after_failed_merge () {
432 while true
433 do
Nikola Forrócce076e2016-04-12 16:44:20 +0200434 printf "Continue merging other unresolved paths [y/n]? "
Junio C Hamanof8750a02012-08-22 22:33:15 -0700435 read ans || return 1
436 case "$ans" in
437 [yY]*)
438 return 0
439 ;;
440 [nN]*)
441 return 1
442 ;;
443 esac
444 done
Charles Baileyb0169d82008-12-12 21:48:40 +0000445}
Steffen Prohaskae3fa2c72007-10-17 19:16:11 +0200446
David Aguilar57937f72016-10-07 16:58:05 -0700447print_noop_and_exit () {
448 echo "No files need merging"
449 exit 0
450}
451
David Aguilar08221e32016-10-07 16:58:04 -0700452main () {
453 prompt=$(git config --bool mergetool.prompt)
Tao Klerks42943b92023-03-18 15:27:43 +0000454 GIT_MERGETOOL_GUI=
David Aguilar08221e32016-10-07 16:58:04 -0700455 guessed_merge_tool=false
David Aguilar654311b2016-10-07 17:01:30 -0700456 orderfile=
Charles Bailey7bfb7c32014-10-11 01:39:37 -0700457
David Aguilar08221e32016-10-07 16:58:04 -0700458 while test $# != 0
459 do
460 case "$1" in
461 --tool-help=*)
462 TOOL_MODE=${1#--tool-help=}
463 show_tool_help
464 ;;
465 --tool-help)
466 show_tool_help
467 ;;
468 -t|--tool*)
469 case "$#,$1" in
470 *,*=*)
Johannes Sixt8b014652019-06-12 18:33:47 +0200471 merge_tool=${1#*=}
David Aguilar08221e32016-10-07 16:58:04 -0700472 ;;
473 1,*)
474 usage ;;
475 *)
476 merge_tool="$2"
477 shift ;;
478 esac
479 ;;
Denton Liu063f2bd2018-10-24 12:25:31 -0400480 --no-gui)
Denton Liu05fb8722019-04-29 02:21:08 -0400481 GIT_MERGETOOL_GUI=false
Denton Liu063f2bd2018-10-24 12:25:31 -0400482 ;;
483 -g|--gui)
Denton Liu05fb8722019-04-29 02:21:08 -0400484 GIT_MERGETOOL_GUI=true
Denton Liu063f2bd2018-10-24 12:25:31 -0400485 ;;
David Aguilar08221e32016-10-07 16:58:04 -0700486 -y|--no-prompt)
487 prompt=false
488 ;;
489 --prompt)
490 prompt=true
491 ;;
David Aguilar654311b2016-10-07 17:01:30 -0700492 -O*)
Richard Hansenc1b0d3a2017-01-10 15:42:01 -0500493 orderfile="${1#-O}"
David Aguilar654311b2016-10-07 17:01:30 -0700494 ;;
David Aguilar08221e32016-10-07 16:58:04 -0700495 --)
496 shift
497 break
498 ;;
499 -*)
500 usage
501 ;;
502 *)
503 break
504 ;;
505 esac
506 shift
507 done
508
509 git_dir_init
510 require_work_tree
511
Felipe Contreras4ecc63d2014-04-20 19:17:34 -0500512 if test -z "$merge_tool"
513 then
Tao Klerks42943b92023-03-18 15:27:43 +0000514 merge_tool=$(get_merge_tool)
515 subshell_exit_status=$?
516 if test $subshell_exit_status = 1
David Aguilar08221e32016-10-07 16:58:04 -0700517 then
David Aguilar08221e32016-10-07 16:58:04 -0700518 guessed_merge_tool=true
Tao Klerks42943b92023-03-18 15:27:43 +0000519 elif test $subshell_exit_status -gt 1
520 then
521 exit $subshell_exit_status
David Aguilar08221e32016-10-07 16:58:04 -0700522 fi
Felipe Contreras4ecc63d2014-04-20 19:17:34 -0500523 fi
David Aguilar08221e32016-10-07 16:58:04 -0700524 merge_keep_backup="$(git config --bool mergetool.keepBackup || echo true)"
525 merge_keep_temporaries="$(git config --bool mergetool.keepTemporaries || echo false)"
Theodore Ts'oc4b4a5a2007-03-06 00:05:16 -0500526
Richard Hansend0e0cfe2017-01-10 15:42:02 -0500527 prefix=$(git rev-parse --show-prefix) || exit 1
528 cd_to_toplevel
529
530 if test -n "$orderfile"
531 then
532 orderfile=$(
533 git rev-parse --prefix "$prefix" -- "$orderfile" |
534 sed -e 1d
535 )
536 fi
537
David Aguilar57937f72016-10-07 16:58:05 -0700538 if test $# -eq 0 && test -e "$GIT_DIR/MERGE_RR"
Junio C Hamanof8750a02012-08-22 22:33:15 -0700539 then
David Aguilar57937f72016-10-07 16:58:05 -0700540 set -- $(git rerere remaining)
541 if test $# -eq 0
David Aguilar08221e32016-10-07 16:58:04 -0700542 then
David Aguilar57937f72016-10-07 16:58:05 -0700543 print_noop_and_exit
David Aguilar08221e32016-10-07 16:58:04 -0700544 fi
Richard Hansend0e0cfe2017-01-10 15:42:02 -0500545 elif test $# -ge 0
546 then
547 # rev-parse provides the -- needed for 'set'
548 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
Junio C Hamanof8750a02012-08-22 22:33:15 -0700549 fi
Charles Baileyb0169d82008-12-12 21:48:40 +0000550
David Aguilar57937f72016-10-07 16:58:05 -0700551 files=$(git -c core.quotePath=false \
David Aguilar654311b2016-10-07 17:01:30 -0700552 diff --name-only --diff-filter=U \
Richard Hansenc1b0d3a2017-01-10 15:42:01 -0500553 ${orderfile:+"-O$orderfile"} -- "$@")
David Aguilar57937f72016-10-07 16:58:05 -0700554
David Aguilar08221e32016-10-07 16:58:04 -0700555 if test -z "$files"
Junio C Hamanof8750a02012-08-22 22:33:15 -0700556 then
David Aguilar57937f72016-10-07 16:58:05 -0700557 print_noop_and_exit
Junio C Hamanof8750a02012-08-22 22:33:15 -0700558 fi
Jonathon Mah3e8e6912011-09-15 19:12:10 -0700559
David Aguilar08221e32016-10-07 16:58:04 -0700560 printf "Merging:\n"
561 printf "%s\n" "$files"
562
563 rc=0
Nicholas Gurievd651a542018-08-13 08:09:29 +0300564 set -- $files
565 while test $# -ne 0
David Aguilar08221e32016-10-07 16:58:04 -0700566 do
567 printf "\n"
Nicholas Gurievd651a542018-08-13 08:09:29 +0300568 if ! merge_file "$1"
David Aguilar08221e32016-10-07 16:58:04 -0700569 then
570 rc=1
Nicholas Gurievd651a542018-08-13 08:09:29 +0300571 test $# -ne 1 && prompt_after_failed_merge || exit 1
David Aguilar08221e32016-10-07 16:58:04 -0700572 fi
Nicholas Gurievd651a542018-08-13 08:09:29 +0300573 shift
David Aguilar08221e32016-10-07 16:58:04 -0700574 done
575
576 exit $rc
577}
578
579main "$@"